/** fMSX: portable MSX emulator ******************************/
/**                                                         **/
/**                          MSDOS.c                        **/
/**                                                         **/
/** This file contains MSDOS-dependent subroutines and      **/
/** drivers. It includes common drivers from Common.h.      **/
/**                                                         **/
/** Copyright (C) Marat Fayzullin 1994,1995                 **/
/**     You are not allowed to distribute this software     **/
/**     commercially. Please, notify me, if you make any    **/
/**     changes to this file.                               **/
/*************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <dos.h>
#include <conio.h>
#include <i86.h>

#include "MSX.h"

char *Title="fMSX MSDOS 0.7";

#define WIDTH  320
#define HEIGHT 240

#define PutImage \
  memcpy((char *)0xA0000,(char *)XBuf+WIDTH*(HEIGHT-200)/2,320*200)

#include "Common.h"

extern void cli();
#pragma aux cli="cli";
extern void sti();
#pragma aux sti="sti";

volatile byte XKeyMap[16] =
{
  0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
  0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
};

byte Keys[][2]={
/*          Esc       1         2         3         4         5         6        */
  { 0,0x00},{ 7,0x04},{ 0,0x02},{ 0,0x04},{ 0,0x08},{ 0,0x10},{ 0,0x20},{ 0,0x40},
/*7         8         9         0         -         =         BS        TAB      */
  { 0,0x80},{ 1,0x01},{ 1,0x02},{ 0,0x01},{ 1,0x04},{ 1,0x08},{ 7,0x20},{ 7,0x08}, 
/*Q         W         E         R         T         Y         U         I        */
  { 4,0x40},{ 5,0x10},{ 3,0x04},{ 4,0x80},{ 5,0x02},{ 5,0x40},{ 5,0x04},{ 3,0x40},
/*O         P         [         ]         Ret       CtrLeft   A         S        */
  { 4,0x10},{ 4,0x20},{ 1,0x20},{ 1,0x40},{ 7,0x80},{ 6,0x02},{ 2,0x40},{ 5,0x01},
/*D         F         G         H         J         K         L         ;        */
  { 3,0x02},{ 3,0x08},{ 3,0x10},{ 3,0x20},{ 3,0x80},{ 4,0x01},{ 4,0x02},{ 1,0x80},
/*'         `         ShiftL    \         Z         X         C         V        */
  { 2,0x01},{ 2,0x02},{ 6,0x01},{ 0,0x01},{ 5,0x80},{ 5,0x20},{ 3,0x01},{ 5,0x08},
/*B         N         M         ,         .         /         ShiftR    *(pad)   */
  { 2,0x80},{ 4,0x08},{ 4,0x04},{ 2,0x04},{ 2,0x08},{ 2,0x10},{ 6,0x01},{ 0,0x01},
/*AltL      Space     Caps      F1        F2        F3        F4        F5       */
  { 6,0x04},{ 8,0x01},{ 6,0x08},{ 6,0x20},{ 6,0x40},{ 6,0x80},{ 7,0x01},{ 7,0x02},
/*F6        F7        F8        F9        F10       NumLock   ScrolLock 7(pad)   */
  { 8,0x10},{ 8,0x20},{ 8,0x40},{ 8,0x80},{ 0,0x01},{ 0,0x01},{ 0,0x01},{ 0,0x01},
/*8(pad)    9(pad)    -(pad)    4(pad)    5(pad)    6(pad)    +(pad)    1(pad)   */
  { 0,0x01},{ 0,0x01},{ 0,0x01},{ 0,0x01},{ 0,0x01},{ 0,0x01},{ 0,0x01},{ 0,0x01},
/*2(pad)    3(pad)    0(pad)    .(pad)                                  F11      */
  { 0,0x01},{ 0,0x01},{ 0,0x01},{ 0,0x01},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x01},
/*F12*/
  {-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},
/*96*/
  {-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},
/*104*/
  {-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},
/*112  */
  {-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},
/*120  */
  {-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},
/*128  */
  {-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},
/*136  */
  {-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},
/*144  */
  {-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},
/*152                                       Ret(pad)  CtrlR*/
  {-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{ 9,0x01},{ 6,0x01},{-1,0x00},{-1,0x00},
/*160  */
  {-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},
/*168  */
  {-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},
/*176                                       /(pad)*/
  {-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{ 2,0x10},{-1,0x00},{-1,0x00},{-1,0x00},
/*184AltR  */
  { 6,0x10},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},
/*192                                                                     Home*/
  {-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00},{ 8,0x02},
/*200Up                           Left                Right               End*/
  { 8,0x20},{-1,0x00},{-1,0x00},{ 8,0x10},{-1,0x00},{ 8,0x80},{-1,0x00},{-1,0x00},
/*208Down     PgDown    Ins       Del*/
  { 8,0x40},{-1,0x00},{ 8,0x04},{ 8,0x08},{-1,0x00},{-1,0x00},{-1,0x00},{-1,0x00}
};


void __interrupt KBDHandler(void)
{
  static int Offset=0;
  register int Key;
  
  cli();
  Key=inp(0x60);
  if(Key==0xE0) Offset+=128;
  else
  {
    if(Keys[Key&0x7f][0]!=-1)
      if(Key&0x80)
        XKeyMap[Keys[Key&0x7f+Offset][0]]|=Keys[Key&0x7f+Offset][1];
       else
        XKeyMap[Keys[Key+Offset][0]]&=~Keys[Key+Offset][1];
    Offset=0;
  }
  outp(0x20,0x20);
  sti();
}


void Keyboard(void)
{
  memcpy(KeyMap,XKeyMap,16); 
  if(ExitFlag)
  {
    if(Verbose) printf("Shutting down...\n"); 
    TrashMSX();exit(0);
  }
}


int InitVGA(void)
{
  union REGS R;
  struct SREGS SR;
  int I,J;
  static byte PalInit[16][3] =
  {
    {0x00,0x00,0x00},{0x00,0x00,0x00},{0x00,0xA0,0x00},{0x60,0xE0,0x60},
    {0x00,0x00,0x90},{0x00,0x00,0xF0},{0xA0,0x00,0x00},{0x00,0xC0,0xE0},
    {0xE0,0x40,0x40},{0xF0,0x80,0x80},{0xC0,0xA0,0x00},{0xE0,0xE0,0x60},
    {0x00,0x60,0x00},{0xE0,0x60,0xE0},{0x80,0x80,0x80},{0xE0,0xE0,0xE0},
  };

  if(Verbose) printf("Initializing VGA drivers:\n  Allocating RAM...");   

  XBuf=(byte *)malloc(sizeof(byte)*WIDTH*HEIGHT);
  if(!XBuf) { if(Verbose) printf("FAILED\n");return(0); }

  /*** Set up 320x200x256 screen mode ***/
  R.w.ax=0x0013;int386(0x10,&R,&R);

  /*** Set palette ***/
  outp(0x3C8,0);
  for(I=0;I<16;I++)
    for(XPal[I]=I,J=0;J<3;J++)
      outp(0x3C9,PalInit[I][J]>>2);
  XPal0=XPal[0];

  /*** Set up keyboard interrupt handler ***/
  R.x.eax=0x2509;
  R.x.edx=FP_OFF((void far *)KBDHandler);
  SR.ds=FP_SEG((void far *)KBDHandler);
  SR.es=0;
  int386x(0x21,&R,&R,&SR);

  if(Verbose) printf("OK\n");
  return(1);
}


void ColorsScrF(void)
{
  byte *P,C;
  int J;

  outp(0x3C8,0);
  for(J=0;J<16;J++)
    for(C=0;C<3;C++)
      outp(0x3C9,Palette[J][C]>>2);

  C=XPal[0]=(!BGColor||SolidColor0)? XPal0:XPal[BGColor];
  for(J=0,P=XBuf;J<HEIGHT*WIDTH;J++) *P++=C;
}
